﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace Rocket_Defense
{
    /*  Bunker Class inherits from SpaceWeapon class.
     *  Bunkers hold all values associated with defensive
     *  bunkers. This class is used to track the health 
     *  and position of a bunker.
    */
    class Bunker : SpaceWeapon
    {
        protected const float _MAXHEALTH = 1000;    // maximum health for each bunker.
        protected Vector2 _drawPos;                 // position used when drawing bunker.  
        public Bunker(Vector2 position, float width, float height)
            :base(new Vector2(position.X - width / 2, position.Y - height/4), width, height)
        {
            _drawPos = position;
            _health = _MAXHEALTH;
        }

        /* DrawPos: accessor/modifier for _drawPos */
        public Vector2 DrawPos
        {
            get { return _drawPos; }
            set { _drawPos = value; }
        }

        /* GetHealthPercent: returns current health percentage. */
        public float GetHealthPercent()
        {
            return _health / _MAXHEALTH;
        }
        /* Exists: returns true if bunker has health remaining, false otherwise. */
        public bool Exists()
        {
            if (Health > 0)
                return true;
            else
                return false;
        }
    }
}
