﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;


namespace Rocket_Defense
{   
    /*  Missile class inherits from SpaceWeapon.
     *  It holds all values associated with enemy
     *  missiles. This class is used to advance a missile
     *  directly to a bunker and keep the angle and
     *  velocity correct.
    */
    class Missile : SpaceWeapon
    {
        Vector2 _tPosition;     // position of target bunker
        Vector2 _motion;        // direction missile needs to go
        float _angle;           // angle to point missile

        public Missile(Vector2 position, Vector2 tPosition, float width, float height, float speed)
            :base(position,width,height,speed)
        {
            _tPosition = tPosition;
            _damage = 100;
            _points = 100;
            _angle = 0;
        }

        /* TargetPosition: accessor/modifier for _tPosition. */
        public Vector2 TargetPosition
        {
            get { return _tPosition; }
            set { _tPosition = value; }
        }

        /* Angle: accessor/modifier for _angle. */
        public float Angle
        {
            get { return _angle; }
            set { _angle = value; }
        }

        /* Update: updates position of missile. */
        public override void Update()
        {
            // creates unit vector of direction to travel and multiplies by speed, then moves missile.
            _motion = _tPosition - _position;
            _motion.Normalize();
            _position += _motion*Speed;

            float x = _tPosition.X - _position.X;
            float y = _tPosition.Y - _position.Y;

            // adjusts angle to keep missile pointing at target bunker.
            Angle = (float)Math.Atan2(-x, y);


        }
    }
}
