﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace Rocket_Defense
{
    class SpaceObject
    {
        /*  SpaceObject Class is designed to be a base class
         *  to create all objects in the game. All objects are built
         *  from SpaceObject.
        */
        protected Vector2 _position;    // holds current position of object
        protected float _speed;         // speed object moves at
        protected float _depth;         // depth object is displayed at
        protected float _height;        // height of object
        protected float _width;         // with of object
        
        //public SpaceObject() { }
        /* <Constructors> */
        public SpaceObject(Vector2 position, float width, float height, float speed, float depth):
            this(width, height, speed,depth)
        {
            _position = position;
        }

        public SpaceObject(Vector2 position, float width, float height, float speed) :
            this(width, height, speed)
        {
            _position = position;
        }

        public SpaceObject(Vector2 position, float width, float height) :
            this(width, height)
        {
            _position = position;
        }
        
        public SpaceObject(float width, float height, float speed, float depth):
            this(width, height,speed)
        {    _depth = depth; }

        public SpaceObject(float width, float height, float speed)
            :this(width,height)
        {   _speed = speed; }

        public SpaceObject(float width, float height)
        {
            _height = height;
            _width = width;
        }
        /* </CONSTRUCTORS> */

        public SpaceObject(Vector2 position)
        { _position = position; }

        /* Position: accessor/modifier for _position. */
        public Vector2 Position
        {
            get { return _position; }
            set { _position = value; }
        }

        /* Depth: accessor/modifier for _depth. */
        public float Depth
        {
            get { return _depth; }
            set { _depth = value; }
        }

        /* Speed: accessor/modifier for _speed. */
        public float Speed
        {
            get { return _speed; }
            set { _speed = value; }
        }

        /* Height: accessor/modifier for _height. */
        public float Height
        {
            get { return _height; }
            set { _height = value; }
        }

        /* Width: accessor/modifier for _width. */
        public float Width
        {
            get { return _width; }
            set { _width = value; }
        }

    }
}
