﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace Rocket_Defense
{
    /*  SpaceWeapon class inherits from SpaceObject.
     *  It is a space object with additional values needed
     *  for the weapons. It is used to create all defensive 
     *  and offensive weapons in the game.
    */
    class SpaceWeapon : SpaceObject
    {
        protected float _damage;        // stores the amount of damage weapon inflicts.
        protected float _points;        // stores the amount of points weapon is worth if destroyed.
        protected float _health;        // stores total health of weapon.

        //public SpaceWeapon() { }
        /* <Constructors> */
        public SpaceWeapon(float depth, float speed)
            : base(depth, speed) { }

        public SpaceWeapon(Vector2 position, float width, float height)
            : base(position, width, height) { }

        public SpaceWeapon(Vector2 position, float width, float height, float speed)
            : base(position, width, height, speed) { }
        public SpaceWeapon(Vector2 position, float width, float height, float speed, float depth)
            : base(position, width, height, speed, depth) { }
        /* </CONSTRUCTORS> */

        /* Damage: accessor/modifier for _damage. */
        public float Damage
        {
            get { return _damage; }
            set { _damage = value; }
        }

        /* Points: accessor/modifier for _points. */
        public float Points
        {
            get { return _points; }
            set { _points = value; }
        }

        /* Health: accessor/modifier for _health. */
        public float Health
        {
            get { return _health; }
            set { _health = value; }
        }

        /* Collides: returns true if collides with sw, otherwise returns false. */
        public bool Collides(SpaceWeapon sw)
        {
            return (Position.X + Width > sw.Position.X &&
                    Position.X < sw.Position.X + sw.Width &&
                    Position.Y + Height > sw.Position.Y &&
                    Position.Y < sw.Position.Y + sw.Height);
        }

        /* Update: default update method, advances weapon straigh down. */
        public virtual void Update()
        {
            _position.Y += _speed;
        }
    }
}
